
libdit_proc *libdit_recv(libdit_t *ctx, struct libdit_msg *msg) {

	switch(ctx->rc_type) {
		default:
		case LIBDIT_RC_UDP:
			return libdit_rc_udp_recv(ctx, msg);
			break;
	}	

}

libdit_proc *libdit_rc_udp_recv(libdit_t *ctx, struct libdit_msg *msg) {
	
	int i;
	libdit_group_t group;
	fd_set fdset;
	
	FD_ZERO(*fdset);
	for(group = ctx->group; group != NULL ; group = group->next) {
		FD_SET(group->socket, *fdset);
	}
	
	select(ctx->group_size + 1, fdset, NULL, NULL, NULL);
	
	for(group = ctx->group; group != NULL ; group = group->next) {
		if(FD_ISSET(group->socket)) {
			recvfrom( /* bla bla bla bla */ );
			/*
			 * UPS! E agora?
			 * S queria ler de um descritor. Vou ter que
			 * criar uma fila para as mensagens recebidas de
			 * modo a conseguir afunilar a funo quando esta
			 * tem dados em mais do que um descritor
			 */
		}
	}



}
