
libdit_send(libdit_t *ctx, u_short proc_id, struct libdit_msg *msg) {

	libdit_group_t *group;
	
	switch(ctx->rc_type) {
		default:
		case LIBDIT_RC_UDP:

			for(group = ctx->group ; group != NULL ; group = group->next) {
				if(group->proc_id == proc_id)
				break;
				if(group == NULL)
					return -1;
			}
			return libdit_rc_udp_send(ctx, group->addr, msg);
			break;
	}	
}

libdit_send_rc_udp(libdit_t *ctx, struct sockaddr_in addr, struct libdit_msg *msg) {
	
	int sd;
		
	sd = socket(AF_INET, SOCK_DGRAM, 0);
	
	sendto(sd, msg, sizeof(struct libdit_msg), 0, addr, sizeof(addr));

}