
int ritas_queue_init(ritas_t *ctx) {
	// LATER
	// PRIME NUMBER HACK GOES HERE!
}

int ritas_queue_destroy(ritas_t *ctx) {
	// LATER
}

int ritas_rb_queue_hash(ritas_t *ctx, ritas_round_t *k) {
	
	int hashcode;
	
	hashcode = k->ip + ( ((int)bsn << 32) + (int)k->port );
	
	return hashcode % ctx->queue_table_size;
}

int ritas_rb_queue_store(ritas_t *ctx, ritas_msg_t *msg) {
	
	int i;
	ritas_queue_head_t *head;	
	ritas_queue_mbuf_t *mbuf;
	
	i = ritas_queue_hash(ctx);
	
	/*
	 * Localize the head.
	 */
	if(!ctx->queue_table[i]) {
		queue_table[i] = malloc(sizeof(ritas_queue_head_t));
		if(!queue_table[i]) {
			return 0;
		}
		head = queue_table[i];
		head->first = NULL;
		head->last = NULL;
		head->next = NULL;
		memcpy(&head->round, &msg->round, sizeof(ritas_round_t));
	}
	else {
		for(head = queue_table[i] ; ; head = head->next) {
			if(!memcmp(head->round, msg->round, sizeof(ritas_round_t)) {
				break;
			}
			if(!head->next) {
				head->next = malloc(sizeof(ritas_queue_head_t));
				head = head->next;
				head->first = NULL;
				head->last = NULL;
				head->next = NULL;
				memcpy(&head->round, &msg->round, sizeof(ritas_round_t));
				break;
			}			
		}

		/*
		 * Insert the message.
		 */
		mbuf = malloc(sizeof(ritas_queue_mbuf_t));
		if(!mbuf) {
			return 0;
		}
		memcpy(&mbuf->msg, msg, sizeof(ritas_msg_t));
		
		if(head->last) {
			head->last->next = mbuf;
			head->last = mbuf;

		}
		else {
			head->last = mbuf;
			head->first = mbuf;
		}
		
		return 1;
}

int ritas_rb_queue_retrieve(ritas_t *ctx, ritas_msg_t *msg, ritas_round_t *round) {

	int i, found;
	ritas_queue_head_t *head;
	ritas_queue_mbuf_t *mbuf;
	
	i = ritas_queue_hash(ctx);
	
	if(!ctx->queue_table[i]) {
		return 0;
	}
	
	head = ctx->queue_table[i];
	
	for(head = queue_table[i] ; head ; head = head->next) {
		if(!memcmp(head->round, msg->round, sizeof(ritas_round_t)) {
			found = 1;
			break;
		}
	}	
	if(!found) {
		return 0;
	}
	
	memcpy(msg, &head->first->msg, sizeof(ritas_msg_t));
	mbuf = head->first;
	head->first = head->first->next;
	if(mbuf == head->last) {
		head->last = NULL;
	}
	free(mbuf);
	
	return 1;	
}
