
int ritas_rb_bcastmsg(ritas_t *ctx, u_char type, char *value, u_short value_s) {
	
	char *buf;
	u_int buf_s;
	ritas_proc_t proc;
	int ret;

	buf_s = RITAS_RB_H + value_s;
	buf = malloc(buf_s);
	if(!buf) {
		return 0;
	}
	
	ret = ritas_rb_build(	buf, 
							buf_s, 
							type, 
							ctx->round,
							char *value, 
							u_short value_s
						);
	if(!ret) {
		return 0;
	}


	for(proc = ctx->group ; proc != NULL ; proc = proc->next) {
		ret = ritas_rc_send(ctx, proc, buf, buf_s);
		if(!ret) {
			return 0;
		}
	}

	free(buf);
	
	return 1;
}

int ritas_rb_sendmsg(ritas_t *ctx, ritas_proc_t *proc, u_char type, ritas_round *k, char *value, u_short value_s) {
	
	char *buf;
	u_int buf_s;


	buf_s = RITAS_RB_H + value_s;
	buf = malloc(buf_s);
	if(!buf) {
		return 0;
	}
	
	ret = ritas_rb_build(	char buf, 
							u_int buf_s, 
							u_char type, 
							ritas_round_t k,
							char *value, 
							u_short value_s
						);
	if(!ret) {
		return 0;
	}

	ret = ritas_rc_send(ctx, proc, buf, buf_s);
	if(!ret) {
		return 0;
	}

	free(buf);
	
	return 1;
}


int ritas_rb_recvmsg(ritas_t *r, ritas_proc_t *proc, ritas_rb_msg *msg) {
	
	int ret;
	
	do {
		ret = queue_retrieve(r, msg, ctx->round);
	}
	while(!ret);
	
	return ret;
}
