#!/usr/bin/python
import os, time, sys

sys.stdout.write("#!/usr/sbin/setkey -f\n")
sys.stdout.write("\n");
line = "# Configuration for 10.0.0.%s\n" % sys.argv[1]
sys.stdout.write(line)
sys.stdout.write("\n");
sys.stdout.write("# AH SAs using 128 bit long keys\n");

# Flush the SAD and SPD

sys.stdout.write("flush;\n");
sys.stdout.write("spdflush;\n");

for ip in range (2,12):
	ips = "%s" % ip
	if(ips <> sys.argv[1]):
		line = "add 10.0.0.%s 10.0.0.%s ah 0x%s%s -A hmac-md5\n" % (sys.argv[1],ip,sys.argv[1],ip)
		sys.stdout.write(line);
		sys.stdout.write("0xc0291ff014dccdd03874d9e8e4cdf3e6;\n");
		line = "add 10.0.0.%s 10.0.0.%s ah 0x%s%s -A hmac-md5\n" % (ip,sys.argv[1],ip,sys.argv[1])
		sys.stdout.write(line);
		sys.stdout.write("0x96358c90783bbfa3d7b196ceabe0536b;\n");
		sys.stdout.write("\n");

sys.stdout.write("\n\n");
sys.stdout.write("# Security policies\n");
for ip in range (2,12):
	ips = "%s" % ip
	if(ip <> sys.argv[1]):
		line = "spdadd 10.0.0.%s 10.0.0.%s any -P out ipsec\n" % (ip,sys.argv[1])
		sys.stdout.write(line)
		sys.stdout.write("           ah/transport//require;\n");
		line = "spdadd 10.0.0.%s 10.0.0.%s any -P in ipsec\n" % (sys.argv[1],ip)
		sys.stdout.write(line)
		sys.stdout.write("           ah/transport//require;\n");
		sys.stdout.write("\n");
