#include <stdio.h>
#include <unistd.h>
#include <sys/time.h>
#include <openssl/md5.h>

#define BUF_SIZE 64
#define toLL(tv) ((tv.tv_sec*(long long)1000000)+tv.tv_usec)

/*
 * Test suite for RITAS
 */
int main(int argc, char **argv) {
	
	u_char buf[BUF_SIZE];
	u_char hash[MD5_DIGEST_LENGTH];
	struct timeval t0, t1;
	int n;
	
	gettimeofday(&t0, NULL);
	MD5(buf, BUF_SIZE, hash);
	gettimeofday(&t1, NULL);	

	for(n = 0 ; n < MD5_DIGEST_LENGTH ; n++)
		printf("%x", (u_char)hash[n]);
	printf(" - %d us\n", toLL(t1)-toLL(t0));
	printf("%d.%d -> %d.%d\n", t0.tv_sec, t0.tv_usec, t1.tv_sec, t1.tv_usec);
}
