#ifndef RITAS_APROXY_H
#define RITAS_APROXY_H

#include <pthread.h>
#include "ritas.h"
#include "ritas_mbuf.h"
#ifdef MEMWATCH
#include "memwatch.h"
#endif

struct ritas_aproxy {
	pthread_mutex_t mutex;
	pthread_cond_t cond;
	u_short count;
	struct ritas_mbuf *mvalue;
};
typedef struct ritas_aproxy ritas_aproxy_t;

int ritas_aproxy_init(ritas_t *ctx);
void ritas_aproxy_destroy(ritas_t *ctx);

#endif // RITAS_APROXY_H
