#include <stdlib.h>
#include <string.h>
#include "ritas_mbuf.h"

ritas_mbuf_t *ritas_mbuf_init() {

	ritas_mbuf_t *m;
	
	m = (ritas_mbuf_t *)malloc(sizeof(ritas_mbuf_t));

	if(!m)
		return NULL;
	
	memset(m, '\0', RITAS_MBUF_DATA_SIZE);
		
	m->tail = m->data + RITAS_MBUF_DATA_SIZE;
	m->head = m->tail;
	m->flags = 0;
	m->prev = m->next = NULL;
	
	return m;
}

void ritas_mbuf_destroy(ritas_mbuf_t *m) {

	if(m)
		if(!(m->flags & RITAS_MBUF_PROTECTED))
			free(m);

}
