#ifndef RITAS_RB_H
#define RITAS_RB_H

ritas_rbcb_t *ritas_rb_init(ritas_t *ctx, u_short txid, u_short id, void *parent, u_char parent_type);
void ritas_rb_destroy(ritas_t *ctx, ritas_rbcb_t *rbcb);
int ritas_rb_renew(ritas_t *ctx, ritas_rbcb_t *rbcb, u_short txid, u_short rbid);
int ritas_rb_input(ritas_t *ctx, ritas_rbcb_t *rbcb, ritas_mbuf_t *m);
int ritas_rb_output(ritas_t *ctx, ritas_rbcb_t *rbcb, ritas_mbuf_t *m);
int ritas_rb_bcast(ritas_t *ctx, u_short rbid, u_char *buf, u_short buf_s);
int ritas_rb_recv(ritas_t *ctx, u_short txid, u_short rbid, u_char *buf, u_short buf_s);

#endif /* RITAS_RB_H */
