
int libdit_build(char *buf, u_int buf_s, u_char type, char *value, u_short value_s) {
	
	/*
	 * Is our buffer large enough?
	 */
	if(buf_s < 4 + value_s) {
		return 0;
	}
	
	memcpy(buf, LIBDIT_RB, 1);
	memcpy(buf + 1, type, sizeof(u_char));
	memcpy(buf + 2, value_s, sizeof(u_short));
	
	memcpy(buf + 4, value, value_s);
	
	return 1;
}

int libdit_rb_extract(libdit_rb_msg *msg, char *buf, u_int buf_s) {
	
	
	if(buf_s < 4) {
		return 0;
	}
	
	memcpy(&msg->protocol, buf, 1);
	if(msg->protocol != LIBDIT_RB) {
		return 0;
	}
	
	memcpy(&msg->type, buf + 1, 1);
	if(msg->type >= 3) {
		return 0;
	}
	
	memcpy(&msg->value_size, buf + 2, sizeof(u_short));
	
	if(msg->value_size > LIBDIT_VALUE_BUF) {
		return 0;
	}
	memcpy(msg->value, buf + 4, msg->value_size);
	
	return 1;
}
